"use strict";
Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "NpmAPI", {
  enumerable: true,
  get: () => NpmAPI
});
const _utils = _export_star(require("./utils"), exports);
function _define_property(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _export_star(from, to) {
  Object.keys(from).forEach(function(k) {
    if (k !== "default" && !Object.prototype.hasOwnProperty.call(to, k)) {
      Object.defineProperty(to, k, {
        enumerable: true,
        get: function() {
          return from[k];
        }
      });
    }
  });
  return from;
}
class NpmAPI {
  npmInstall({ cwd, registryUrl, ignoreScripts }) {
    return (0, _utils.npmInstall)({
      cwd: cwd || this.generatorCore.outputPath,
      registryUrl,
      ignoreScripts
    });
  }
  yarnInstall({ cwd, registryUrl, ignoreScripts }) {
    return (0, _utils.yarnInstall)({
      cwd: cwd || this.generatorCore.outputPath,
      registryUrl,
      ignoreScripts
    });
  }
  pnpmInstall({ cwd, registryUrl, ignoreScripts }) {
    return (0, _utils.pnpmInstall)({
      cwd: cwd || this.generatorCore.outputPath,
      registryUrl,
      ignoreScripts
    });
  }
  constructor(generatorCore) {
    _define_property(this, "generatorCore", void 0);
    this.generatorCore = generatorCore;
  }
}
