"use strict";
Object.defineProperty(exports, "__esModule", {
  value: true
});
function _export(target, all) {
  for (var name in all)
    Object.defineProperty(target, name, {
      enumerable: true,
      get: all[name]
    });
}
_export(exports, {
  canUseNvm: () => canUseNvm,
  canUseNpm: () => canUseNpm,
  canUseYarn: () => canUseYarn,
  canUsePnpm: () => canUsePnpm
});
const _utils = require("@modern-js/utils");
async function canUseNvm() {
  try {
    await (0, _utils.execa)("source ~/.nvm/nvm.sh", {
      env: process.env,
      shell: true
    });
    return true;
  } catch (e) {
    return false;
  }
}
async function canUseNpm() {
  try {
    await (0, _utils.execa)("npm", [
      "--version"
    ], {
      env: process.env
    });
    return true;
  } catch (e) {
    return false;
  }
}
async function canUseYarn() {
  try {
    await (0, _utils.execa)("yarn", [
      "--version"
    ], {
      env: process.env
    });
    return true;
  } catch (e) {
    return false;
  }
}
async function canUsePnpm() {
  try {
    await (0, _utils.execa)("pnpm", [
      "--version"
    ], {
      env: process.env
    });
    return true;
  } catch (e) {
    return false;
  }
}
